<?php
	
	// Open images folder and apply either a usericon or a background icon
	include_once 'data_connect.php';
	include 'log.php';

	//mypanel.php stuff included here
	libxml_clear_errors();
	libxml_use_internal_errors(true);
	
	
	// Check settings file condition
	if (!file_exists('filesinfo/settings.xml'))
		exit('Could not load page. Settings file is missing');
		
	$settingsXML = simplexml_load_file('filesinfo/settings.xml');
		
	if ($settingsXML === false)
		exit('Error: Settings file is corrupt');	

	// Number of images to show each time the autoloader starts
	$imgloader = $_SESSION['ImageLoader']
		

?>
<!doctype html>
<html>
<head>
<meta charset="utf-8">
<title>Images</title>
<link rel="stylesheet" type="text/css" href="cmstyle.css">
<?php include 'csstheme.php' ?>
<style>
	@charset "utf-8";
	html,body{min-height:initial}
	.spinner{position:relative;display:none;top:8px;clear:both;height:30px;right:0;left:0}
	.spinnerautoload{display:block}
	.spinner > div{width:10px;height:10px;background-color:#111;animation:sk-bouncedelay 1s infinite ease-in-out both;-webkit-animation:sk-bouncedelay 1s infinite ease-in-out both}
</style>
<script>
	function selectThis(e) { 
		
		if (document.getElementsByClassName('user current-use').length > 0)
			document.getElementsByClassName('user current-use')[0].className = 'user';
		
		e.className = 'user current-use';
		
	}
	
	function setImg(e) {
		
		var icon = document.getElementById('seticon');
		if (e.className == 'user'){
			var set = new XMLHttpRequest();
			var param = 'usethis=' + e.getAttribute('data-img');


			if (icon.className == 'stylish-button iconstyle readyicon')
				icon.className = 'stylish-button iconstyle';

			set.open('POST','setimage.php',true);
			set.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
			set.onreadystatechange = function() {
				if (this.readyState === 4 && this.status === 200) {
					icon.className = 'stylish-button iconstyle readyicon';
				}
			}
			set.send(param);
		}
	}
</script>
</head>
<body style="overflow-x:hidden;height:100%">
	<?php
	
	if (isset($_SESSION['usericon']))
		$in_use = $_SESSION['usericon'];
	else
		$in_use = get_account($_SESSION['userID'])['icon']
	
	
	?>
	<div style="height:260px;position:fixed;background-color:#fcfcfc;left:0;right:0;z-index:99;border-bottom:1px solid #ddd">
		<div class="des" style="margin:12px">Choose a user image from your website images</div>
		<div id="userimages-wrap">
			<div id="userimages">
			<?php

				$array_img = array();
				$array_mtime = array();

				$directory = new DirectoryIterator('../images/');

				foreach ($directory as $fileinfo) {

					if ($fileinfo->isFile()) {

						$name = $fileinfo->getFilename();
						$ext = $fileinfo->getExtension();
						$mtime = $fileinfo->getMtime();

						if (strpos('.png .jpg .gif',$ext) !== false) {
							$array_img[]= $name;
							$array_mtime[] = $mtime;
						}
					}	
				}


				rsort($array_mtime);


				$i=0;
				foreach($array_mtime as $mt) {

					foreach($array_img as $imgkey=>$img) {

						if (filemtime('../images/'.$img) == $mt) {

							if ($i < $imgloader) {

								$inuseclass = '';
								$na = '';
								$im = '../images/'.$img;


								if ($im == $in_use)
									$inuseclass = ' current-use';

								$dataim = basename($im);

							echo '<div class="user-icon-wrap'.$indicator.'"><a href="#123selectthis" class="user'.$inuseclass.'" data-img="'.$dataim.'" style="background-image:url(\''.$im.'\')" onclick="setImg(this);selectThis(this);"></a></div>'.PHP_EOL;

								unset ($array_img[$imgkey]);

								$i++;
							}
						}
					}
				}



				if ($array_mtime[$imgloader]) : ?> 
				<a href="#123loadmore" class="loadmoreimg" onclick="loadnow(this)">Load More</a>

					<script>
					function loadnow(e) {
						e.style.opacity = 0;
						document.getElementsByClassName('spinner')[0].className = 'spinner spinnerautoload';
						var autoload = new XMLHttpRequest();
						autoload.open('GET', 'autoloader.php', true);
						autoload.onreadystatechange = function() {

							if (this.readyState === 4 && this.status === 200) {
								document.getElementsByClassName('spinner')[0].className = 'spinner';
								var node = document.createElement('SPAN');
								var txt = autoload.responseText;
								node.innerHTML = txt;
								document.getElementById('userimages').appendChild(node);
								e.style.display = 'none';

							}
						}
						autoload.send();
					}



					</script>

				<?php endif ?>
			
			</div>
		</div>
		<input type="button" value="Select" style="visibility:visible;opacity:.2;cursor:default;background-color:#000" class="stylish-button iconstyle" disabled="">
		<input id="seticon" type="button" value="Select" class="stylish-button iconstyle" onclick="parent.closediv()">
		<div class="spinner">
			<div class="bounce1"></div>
			<div class="bounce2"></div>
			<div class="bounce3"></div>
		</div>
		<div style="height:5px;clear:both"></div>
	</div>
</body>
</html>